/*	$Id: c-bsd2.c,v 1.1.1.1 2005/09/25 22:25:52 tho Exp $ */

/* 
 * Copyright (c) 2007 Anthony Mallet                  --  Thu Feb  1 2007
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

#include <err.h>

#include <t3d/t3d.hpp>

int
main()
{
  CT3D s, *t;
  CV3D a, b;
  int i;

  t = new CT3D(t3dMatrixIdentity);
  if (!t) errx(2, "cannot allocate CT3D");
  warnx("T3D allocation ok");

  t->matrix(0) = 2.0;
  if (t->matrix(0) != 2.0)
    errx(2, "affection of single element not working");
  warnx("affection of single element ok");
  t->matrix(0) = 1.0;

  s = *t;
  for(i=0;i<16;i++) if (t->matrix(i) != s.matrix(i))
    errx(2, "affection not working");
  warnx("affectation ok");

  s = t->inv();
  for(i=0;i<16;i++) if (t->matrix(i) != s.matrix(i))
    errx(2, "inversion not working");
  warnx("inversion ok");

  b = s * a;
  for(i=0;i<16;i++) if (t->matrix(i) != s.matrix(i))
    errx(2, "vector transofrmation not working");
  warnx("vector transformation ok");

  return 0;
}
